
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Apache整合Tomcat（转） / 憋错料</title>

    <meta name="description" content="Apache整合Tomcat（转） 一.先从J2EE工程的通用架构说起 这是一个通用的Web即B/S工程的架构,它由: ü   Web Server ü   App Server ü   DB Server 三大部分组成,其中: ²  Web Server 置于企业防火墙外,这个防火墙,大家可以认为是一个CISCO路由器,然后在CISCO路由器上开放了两个端口为:80和443. 80端口:用于正常的http访问 443端口:用于https访问,即如果你在ie里打入https://xxx.xxx.xx这样的地址,默认 走的是443这">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Apache整合Tomcat（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>一、先从J2EE工程的通用架构说起</h1>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLm15LmNzZG4ubmV0L3VwbG9hZHMvMjAxMjEyLzEyLzEzNTUyODUyMjJfNTQzNC5qcGc=.jpg" /></p>
<p>这是一个通用的Web即B/S工程的架构，它由：</p>
<p>&uuml;&nbsp;&nbsp; Web Server</p>
<p>&uuml;&nbsp;&nbsp; App Server</p>
<p>&uuml;&nbsp;&nbsp; DB Server</p>
<p>三大部分组成，其中：</p>
<p>&sup2;&nbsp; Web Server</p>
<p>置于企业防火墙外，这个防火墙，大家可以认为是一个CISCO路由器，然后在CISCO路由器上开放了两个端口为：80和443。</p>
<p>80端口：用于正常的http访问</p>
<p>443端口：用于https访问，即如果你在ie里打入<a href="https://xxx.xxx.xx/" rel="external nofollow noreferrer">https://xxx.xxx.xx</a>这样的地址，默认</p>
<p>走的是443这个端口。</p>
<p>WebServer专门：</p>
<p>用于解析HTML、JS（JavaScript）、CSS、JPG/GIF等图片格式文件、TXT、</p>
<p>VBSCRIPT、PHP等一切一切&ldquo;静态&rdquo;网页内容。</p>
<p>&sup2;&nbsp; App Server</p>
<p>置于企业防火墙内，它和Web Server之间的连接必须且一定为内部IP连接。</p>
<p>外部IP：即Internet IP地址，我们的web服务器一般会有一个内部IP一个外部IP，因此在这里，我们的App Server没有任何外部IP，只有内部IP，所以我在这边说App Server与Web Server只能以内部IP形式连接。</p>
<p>打比方说我们用的是tomcat，它的端口为8080，那么这个ip地址上的8080端口只能由任何内部ip才能访问，外部的internet是访问不了的，这样做就是为了安全。</p>
<p>App Server用于解析我们的任何需要Java编译器才能解析的&ldquo;动态&rdquo;网页，其实App Server本身也能解析任何静态网页的。</p>
<p>那么我们这样来想一下：</p>
<p>我们让负责专门解析静态网页的Web Server来解析html等内容，而让App Server专门用于解析任何需要Java编译器才能解析的东西，让它们&ldquo;两人&rdquo;各司其职。这样作的好处：</p>
<p>1）&nbsp;&nbsp;&nbsp;&nbsp;为App Server&ldquo;减压&rdquo;，同时也提高了performance</p>
<p>2）&nbsp;&nbsp;&nbsp;&nbsp;不用再把8080这个端口暴露在internet上了，也很安全，必经我们的app server上可是有我们的代码的，就算是编译过的代码也容易被&ldquo;反编译&rdquo;，这是很不安全的。</p>
<p>3）&nbsp;&nbsp;&nbsp;&nbsp;为将来的进一步的&ldquo;集群扩展&rdquo;打好了基础</p>
<p>&sup2;&nbsp; DB Server</p>
<p>打比方说我们用的是Oracle，它需要通过1521与App Server进行连接是不是？那么这个1521我们称为数据库连接端口，如果把它暴露在Internet上，是不是在危险了点？就算我们的密码很复杂，但对于高明的黑客来说，要攻破你的口令也只是时间上的问题而己。</p>
<p>因此我们把我们的DB Server也和App Server一样，置于内网的防火墙。任何的DB连接与管理只能通过内网即在公司企业内部来访问，就是这个道理。</p>
<h1>二、动手来架构</h1>
<h2>2.1 Oracle数据加的安装与配置</h2>
<p>DB(Oracle)我已经为大家准备好了，连接信息为：</p>
<table>
<tbody>
<tr>
<td>
<br /><strong>IP：</strong></p>
</td>
<td>
<br /><strong>10.225.10x.xx</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>Port:</strong></p>
</td>
<td>
<br /><strong>1521</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>Username/Password:</strong></p>
</td>
<td>
<br /><strong>xxx/xxx</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>Sid:</strong></p>
</td>
<td>
<br /><strong>Jcoedb1</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>url:</strong></p>
</td>
<td>
<br /><strong>jdbc:oracle:thin:@10.225.10x.xx:1521:xxx</strong></p>
</td>
</tr>
</tbody>
</table>
<p>所以，根据上述的架构，我们可以把如下这样的一份清单丢给NSS或者是相关的网络管理部门，让他们给我们开通相应的端口：</p>
<table>
<tbody>
<tr>
<td>
<br /><strong>Web Server</strong></p>
</td>
<td>
<br /><strong>对外IP: xxx.xxx.xxx.xxx<br />对内IP：10.225.xxx.xxx</strong></p>
<p><strong>向internet开通80与443端口</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>App Server</strong></p>
</td>
<td>
<br /><strong>对内IP: 10.225.xxx.xxx</strong></p>
<p><strong>只对10.225.段的ip开放8080,8009等端口，</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>Db Server</strong></p>
</td>
<td>
<br /><strong>对内IP: 10.225.xxx.xxx</strong></p>
<p><strong>只对10.225.段的ip开放1521端口</strong></p>
</td>
</tr>
</tbody>
</table>
<h2>2.2 App Server的安装</h2>
<p>直接解压tomcat至你的本地如：d:\tomcat，我这边用的目录名叫tomcat2，大家随意，最好名字能够越简单越好d:\tomcat或者c:\tomcat就行，不要放得太&ldquo;深&rdquo;。</p>
<h2>2.3 Web Server的安装</h2>
<p>我们在这边将安装Apache For Win 2.2.x，它将占用你机器的80和443端口。因此如果你机器上有任何程序占用你的80和443端口，必须将它关闭掉，比如说：</p>
<p><em>我们装有微软的IIS，这本身也是一个WebServer，那么请你将它关闭：</em></p>
<p><em>ControlPanel-&gt;Administrative Tools-&gt;Service，找到IISAdmin和，将它全部关闭并将启动方式设为:manual以便于不用每次重启后再要去手动关闭一下。</em></p>
<p><em>然后用netstat &ndash;ano找到任何还在占用80端口的程序，将它关闭掉。</em></p>
<h2>2.4&nbsp;开始安装Apache Http Server</h2>
<p>我们将安装这个版本的apache http server作为我们今后一直使用的Web Server</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTQxM180OTU3LmpwZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTQ0NF81OTc1LmpwZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTQ0OF8xNzYwLmpwZw==.jpg" /><strong><br /></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTQ5NF82NTEzLmpwZw==.jpg" /></strong></p>
<p><strong>这边的server name你们要填入自己的server的真实名，不能用我这个，这个servername如：shnlap93.cts.com只能够我用，这个名称是全局唯一的，和你的IP一样。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTUzM185NzYzLmpwZw==.jpg" /></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTU2MV80MzUzLmpwZw==.jpg" /></strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>选全部安装</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTU5NV8zMjM4LmpwZw==.jpg" /></p>
<p>装完后你会多出一个这样的图标来，点击该图标，里面有用于控制apache http server的启动、停止与重启等操作选项。同时在你们的&ldquo;服务&rdquo;面板中，也能发现这样的一个服务项，它启动时默认是随着系统的启动而启动的，我们把它改成&ldquo;手动&rdquo;吧，因为将来我们还要安装IBM Http Server来作练习。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTczOV8xNjI4LmpwZw==.jpg" /></p>
<p>装完后，在Apache2.2启动的前提下，打开一个ie输入<a href="http://localhost/" rel="external nofollow noreferrer">http://localhost</a>，你将会得到这样的一个页面，就说明你的Apache的安装是成功的。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTc2OV82NDk2LmpwZw==.jpg" /></p>
<h2>2.5 Apache的配置</h2>
<p>学Java的人，必须会这个Apache的配置，要不然你怎么模拟环境、搭建环境和架构环境？光会Coding是远远不够的，你将永远只配作个码农。。。嘿嘿嘿！有很多人发觉到了后面JAVA学不上去了，关键因素在于：配置。</p>
<p>你会配环境了，那么你就能模拟任何客户方、开发方的环境。</p>
<p>你会配环境了，你的代码将来上线时才能成功运行。</p>
<p>你会配环境了，所以整个工程的技术核心就是你。</p>
<p>跟着我的教程，你们将会安装和运行达近百个各种软件与配置，搞得你一股臭味一股臭味！！</p>
<p>你准备好了没有？</p>
<p>当然，不用怕，因为我的配置都是实际运行的环境，所以网上的一些东西你可以不用去看，因为很多人都是在网上进行拷贝、复制，有时也不经过验证，会让你走很多的弯路到头来还是落得个BUG一天世界，就看我的教程吧。</p>
<p>Apache的配置主要集中在<strong>httpd.conf</strong>文件，它位于你的安装目录，比如：</p>
<p><strong>D:\tools\httpd\conf\</strong></p>
<p>我们用ultraedit或者相关文本编辑工具打开它，来看它的内容：</p>
<p>先来查找到如下这一行：</p>
<p>#ServerName</p>
<p>我们可以得到如下这一行内容：</p>
<table>
<tbody>
<tr>
<td>
<br />#ServerName shnlap93.cts.com:80</p>
</td>
</tr>
</tbody>
</table>
<p>这就是我们的主机名了，我们可以将前面的&ldquo;#&rdquo;去掉，并将其改为：</p>
<table>
<tbody>
<tr>
<td>
<br />ServerName 10.225.106.35:80</p>
</td>
</tr>
</tbody>
</table>
<p>改完后存盘，在重启你的Apache2.2前我们先测试一下我们的Apache的配置文件是否改得对：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTgwNF81NjAyLmpwZw==.jpg" /></p>
<p>如果在你点了Test Configuration后，黑屏一闪而过，说明你的改动无误，否则这个黑屏会一直停留在当前状态，并且告诉你，你的配置改动有错，错在哪里。</p>
<p>重新启动你的Apache</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTgzM181MjI3LmpwZw==.jpg" /></p>
<p>找到如下这行：</p>
<p>DocumentRoot</p>
<p>你会发下有这样的一行内容：</p>
<table>
<tbody>
<tr>
<td>
<br />DocumentRoot "D:/tools/httpd/htdocs"</p>
</td>
</tr>
</tbody>
</table>
<p>这个叫作DocumentRoot即webroot，即：发布目录，发布在这个目录下的任何工程都会在Apache服务开启时被装载成标准的web工程，我们现在动手来把这个WebRoot定位到我们自己的发布目录中去吧。</p>
<table>
<tbody>
<tr>
<td>
<br />DocumentRoot "d:/www"</p>
</td>
</tr>
</tbody>
</table>
<p>我们把它改到了d盘的www目录中去了，然后我们在该目录中放入一个index.html文件，内容为：</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;html&gt;&lt;body&gt;&lt;h1&gt;Hey man, apache works!&lt;/h1&gt;&lt;/body&gt;&lt;/html&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>重启我们的Apache服务，来测试一下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTg1OV81Mzk1LmpwZw==.jpg" /></p>
<p>嘿嘿，我们得到了什么？禁止访问，为什么？</p>
<p>找到下面这一段：</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;Directory /&gt;</p>
<p>Options FollowSymLinks</p>
<p>AllowOverride None</p>
<p>Order deny,allow</p>
<p><strong>deny from all</strong></p>
<p>&lt;/Directory&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>看到了没？</p>
<p>现在，把这个&rdquo;deny from all&rdquo;改成&rdquo;allow fromall&rsquo;吧。</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;Directory /&gt;</p>
<p>Options FollowSymLinks</p>
<p>AllowOverride None</p>
<p>Order deny,allow</p>
<p><strong>allow from all</strong></p>
<p>&lt;/Directory&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>修改完后重启你的Apache服务</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTg4NF8zMTE5LmpwZw==.jpg" /></p>
<p>Ok,我们的Apache的发布目录已经成功更改到了d:\www目录下了，我们再来做一个实验：</p>
<p>我们在IE浏览器中输入: http://localhost/css/，我们看到了什么？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTkxMV81NDAxLmpwZw==.jpg" /></p>
<p>这还了得，用户如果是个初级黑客都可以知道我们的服务器上有哪些文件，哪些目录甚至可以直接看到我们的文件内容，怎么办？</p>
<p>找到下面这行</p>
<table>
<tbody>
<tr>
<td>
<br />Options FollowSymLinks indexes</p>
</td>
</tr>
</tbody>
</table>
<p>把它注掉改成下面这样</p>
<table>
<tbody>
<tr>
<td>
<br />#Options FollowSymLinks indexes</p>
<p>Options None</p>
</td>
</tr>
</tbody>
</table>
<p>不要急，再往下找，还有</p>
<table>
<tbody>
<tr>
<td>
<br />Options Indexes FollowSymLinks</p>
</td>
</tr>
</tbody>
</table>
<p>又来一个，再改掉</p>
<table>
<tbody>
<tr>
<td>
<br />#Options Indexes FollowSymLinks</p>
<p>Options None</p>
</td>
</tr>
</tbody>
</table>
<p>改完这两条后重启你的Apache服务</p>
<p>再次打开一个新的IE，输入：<a href="http://localhost/css/" rel="external nofollow noreferrer">http://localhost/css/</a>，我们看到了如下的界面：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTkzNl8xODAyLmpwZw==.jpg" /></p>
<p>好了，Apache的基本配置完成了即：</p>
<p>1）&nbsp;&nbsp;基本的安全配置，不允许目录访问</p>
<p>2）&nbsp;&nbsp;把WebRoot改到另一个物理目录上而不使用Apache自带的WebRoot目录</p>
<h2>2.6&nbsp;整合Apache与Tomcat</h2>
<p>Apache(Web Server)负责处理HTML静态内容；</p>
<p>Tomcat(App Server)负责处理动态内容；</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDYvMjgvMTM0MDg1MTk2MF85MzkwLmpwZw==.jpg" /></p>
<p>其实就是上述这样的一个架构，下面是原理</p>
<p>1)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Apache装有一个模块，这个模块叫mod_jk</p>
<p>2)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Apache通过80端口负责解析任何静态web内容</p>
<p>3)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;任何不能解析的内容，用表达式告诉mod_jk，让mod_jk<strong>派发</strong>给相关的app server去解释。</p>
<p>通过上述的文字描述我们可以得知：</p>
<p>1）&nbsp;&nbsp;我们需要在Apache中先装一个mod_jk</p>
<p>2）&nbsp;&nbsp;我们需要在httpd.conf中写点表达式</p>
<p>下面来实现。</p>
<p>1)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;把mod_jk-1.2.31-httpd-2.2.3.so手工copy进我们的Apache安装目录的modules目录下，这个文件的全名叫: mod_jk-1.2.31-httpd-2.2.3.so，大家可以从ftp上的&ldquo;/JavaArchitect/mod_jk/&rdquo;目录中获取，因为这个文件是我用C++在本地重新编译过的，网上下载的是src即源码，省去大家再去编译的时间了，而且一些其它网上下载的mod_jk.so是无法使用的。</p>
<p>2)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;用ultraedit打开httpd.conf文件，跑到文件最后面加入以下几行：</p>
<table>
<tbody>
<tr>
<td>
<br />LoadModule jk_module modules/mod_jk-1.2.31-httpd-2.2.3.so</p>
<p>JKWorkersFile conf/workers.properties</p>
<p>JkLogFile logs/mod_jk.log</p>
<p>&lt;VirtualHost *&gt;</p>
<p>ServerAdmin localhost</p>
<p>DocumentRoot d:/www/</p>
<p>ServerName localhost</p>
<p>DirectoryIndex index.html index.htm index.jsp index.action</p>
<p>ErrorLog logs/shsc-error_log.txt</p>
<p>CustomLog logs/shsc-access_log.txt common</p>
<p>JkMount /*WEB-INF ajp13</p>
<p>JkMount /*j_spring_security_check ajp13</p>
<p>JkMount /*.action ajp13</p>
<p>JkMount /servlet/* ajp13</p>
<p>JkMount /*.jsp ajp13</p>
<p>JkMount /*.do ajp13</p>
<p>JkMount /*.action ajp13</p>
<p>JkMount /*fckeditor/editor/filemanager/connectors/*.* ajp13</p>
<p>JkMount /fckeditor/editor/filemanager/connectors/* ajp13</p>
<p>&lt;/VirtualHost&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>关键的是这两句：</p>
<p>LoadModule jk_module modules/mod_jk-1.2.31-httpd-2.2.3.so</p>
<p>JKWorkersFile conf/workers.properties</p>
<p>代表：</p>
<p>&uuml;&nbsp;&nbsp; Apache载入一个额外的插件，用于连接tomcat。</p>
<p>&uuml;&nbsp;&nbsp; 连接时的配置参数描述位于Apache安装目录的/conf目录下的一个叫workers.properties文件中，mod_jk一般使用ajp13协议连接，使用的是tomcat的8009端口。</p>
<p>3)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Worker.properties文件内容如下：</p>
<table>
<tbody>
<tr>
<td>
<br />workers.tomcat_home=d:/tomcat2</p>
<p>workers.java_home=C:/jdk1.6.32</p>
<p>ps=/</p>
<p>worker.list=ajp13</p>
<p>worker.ajp13.port=8009</p>
<p>worker.ajp13.host=localhost</p>
<p>worker.ajp13.type=ajp13</p>
</td>
</tr>
</tbody>
</table>
<p>4)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;告诉我们的Apache，哪些是要交给tomcat来解析，<strong>除此之外都由Apache本身来解析</strong>：</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;VirtualHost *&gt;</p>
<p>ServerAdmin localhost</p>
<p>DocumentRoot d:/www/</p>
<p>ServerName localhost</p>
<p>DirectoryIndex index.html index.htm index.jsp index.action</p>
<p>ErrorLog logs/shsc-error_log.txt</p>
<p>CustomLog logs/shsc-access_log.txt common</p>
<p>JkMount /*WEB-INF ajp13</p>
<p>JkMount /*j_spring_security_check ajp13</p>
<p>JkMount /*.action ajp13</p>
<p>JkMount /servlet/* ajp13</p>
<p>JkMount /*.jsp ajp13</p>
<p>JkMount /*.do ajp13</p>
<p>JkMount /*.action ajp13</p>
<p>JkMount /*fckeditor/editor/filemanager/connectors/*.* ajp13</p>
<p>JkMount /fckeditor/editor/filemanager/connectors/* ajp13</p>
<p>&lt;/VirtualHost&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>大家看到没，所有的/servlet/*都由tomcat负责解析，所有的jsp, .do, .action都由tomcat解析。</p>
<p>此处还有一个特殊的/fckeditor，这个是我们使用的一个博客编辑器，这个因为是servlet的，因此也需要交给tomcat铁析。</p>
<p>5)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;将/cbbs工程布署到tomcat的webapps目录下</p>
<p>6)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;将/cbbs同样手工copy一份到d:/www目录下</p>
<p>7)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;删除d:/www/cbbs/WEB-INF这个目录，嘿嘿，因为d:/www下的东西是由Apache解析的，所有的WEB-INF下的都是Java，我们只需要布署在tomcat下即可，是不是？</p>
<p>8)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;重启tomcat，重启Apache，在ie中直接输入：&nbsp;<a href="http://localhost/cbbs" rel="external nofollow noreferrer">http://localhost/cbbs</a>，使用sally/abcdefg登录，操作一下，一切成功</p>
<p>Oh&hellip;yeah, tomcat+apache一步搞定。</p>
<h1>三、用于实验的cbbs工程配置</h1>
<p><strong><em>最后附上cbbs布署需要用到的配置，相关的工程可通过ftp的&rdquo; /Java Architect/Project/&rdquo;下的cbbs.zip来获取。</em></strong></p>
<p>&uuml;&nbsp;&nbsp; 在tomcat中打开server.xml加入：</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;Resource</p>
<p>driverClassName="oracle.jdbc.OracleDriver"</p>
<p>factory="org.apache.commons.dbcp.BasicDataSourceFactory"</p>
<p>maxActive="25" maxIdle="100" maxWait="5000" name="jdbc/eltds"</p>
<p>password="xxx"</p>
<p>type="javax.sql.DataSource"</p>
<p>url="jdbc:oracle:thin:@10.225.101.51:1521:jcoedb1"</p>
<p>username="xxx"/&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>和</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;Context crossContext="true" docBase="D:/upload" path="/uploadpic" reloadable="true"/&gt;</p>
<p>&lt;Context docBase="cbbs" path="/cbbs" reloadable="true"/&gt;</p>
</td>
</tr>
</tbody>
</table>
<p>&uuml;&nbsp;&nbsp; 手工在d盘根目录建立一个upload目录，在此目录内再建立一个image目录。</p>
<p>&uuml;&nbsp;&nbsp; 在tomcat中打开context.xml加入</p>
<table>
<tbody>
<tr>
<td>
<br />&lt;ResourceLink&nbsp;&nbsp; name="jdbc/cbbsds"&nbsp;&nbsp; type="javax.sql.DataSource"&nbsp;&nbsp; global="jdbc/cbbsds"/&gt;</p>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 06:23:15 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Apache整合Tomcat（转）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/W0jDDW4.html" rel="bookmark">apache整合tomcat部署集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近日,由于公司项目需要,所以学习了apache整合tomcat以及集群的一些知识. 所以做下笔记日后回顾可以用到. apache只有处理静态事物的能力, 而tomcat的强项就是处理动态的请求,所以apache和tomcat整合相互取长补短,由apache作为入口,如果是请求静态页面或者是静态文件,由apache直接提供,如果是请求动态页面,则让apache分发到tomcat,由tomcat处理以后再响应给客户端. apache和tomcat的整合需要准备的一些软件列表: 图1 说明: 1.首先			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wrjdl0.html" rel="bookmark">Apache整合Tomcat、集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1     使用mod_proxy整合 使用mod_proxy整合Tomcat需要我们开启Apache的代理功能,代理功能的开启可以通过在Apache的conf/httpd.conf文件中将如下内容前的“#”号去除,这样Apache就能在运行的时候加载mod_proxy模块了,从而开启了Apache的代理功能. #LoadModule proxy_module modules/mod_proxy.so 开启了mod_proxy之后我们还需要选择一个协议来作为Apache代理Tomcat的协议			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jlZOe4.html" rel="bookmark">Apache整合Tomcat连接数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Apache与Tomcat比较联系 apache支持静态页,tomcat支持动态的,比如servlet等. 一般使用apache+tomcat的话,apache只是作为一个转发,对jsp的处理是由tomcat来处理的. apache可以支持php\cgi\perl,但是要使用java的话,你需要tomcat在apache后台支撑,将java请求由apache转发给tomcat处理. apache是web服务器,Tomcat是应用(java)服务器,它只是一个servlet(jsp也翻译成se			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rBkyg3.html" rel="bookmark">Apache整合Tomcat</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				0.安装apache2.2 ./configure --prefix=/usr/local/apache --enable-so \ --enable-rewrite --with-mpm=worker make &amp;&amp; make install 1.安装jdk tar zxvf jdk-7-linux-i586.gz mv jdk1.7.0 /usr/local/jdk /usr/local/jdk/bin/java --version 2.安装tomcat7.0.37 tar zxvf			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME7pOX3.html" rel="bookmark">Apache整合Tomcat的相关问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 在开发中遇到一个问题,tomcat 与Apache服务器适配的问题.客户那边是用wampserver这个集成软件,Aapche版本为2.4.9.想要将tomcat上的jsp显示在Apache上.Tomcat,jdk,Apache的安装我在这里就不多说了,我们直接来解决这个问题. 二.处理步骤   1.首先我们要去tomcat的官网上下载两个服务器的连接器 地址为http://tomcat.apache.org/download-connectors.cgi 单击Binary Relea			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZAzed0.html" rel="bookmark">2&period; apache整合tomcat部署集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
							</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qRKGP4.html" rel="bookmark">linux&plus;jre&plus;apache&plus;mysql&plus;tomcat调优</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.不再为Apache进程淤积.耗尽内存而困扰 0. /etc/my.cnf,在mysqld那一段加上如下一行: log-slow-queries=queries-slow.log 重启MySQL 酌情过上一段时间,执行mysqldumpslow命令,或直接查看datadir/queries-slow.log,从中找出执行超时的SQL语句.其中datadir是MySQL所有数据库的存放路径. 根据上一步找出的SQL语句的内容,找到相应的数据表和脚本文件,查看超时原因所在.可能的原因有:数据量确实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r581w0.html" rel="bookmark">&lbrack;WebServer&rsqb; Linux下Apache与Tomcat整合的简单方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Apache与Tomcat比较联系 apache支持静态页,tomcat支持动态的,比如servlet等. 一般使用apache+tomcat的话,apache只是作为一个转发,对jsp的处理是由tomcat来处理的. apache可以支持php\cgi\perl,但是要使用java的话,你需要tomcat在apache后台支撑,将java请求由apache转发给tomcat处理. apache是web服务器,Tomcat是应用(java)服务器,它只是一个servlet(jsp也翻译成serv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVYQjd4.html" rel="bookmark">&lbrack;WebServer&rsqb; Windows下Apache与Tomcat的整合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://bbs.blueidea.com/thread-2873268-1-1.html 准备工作:1. Apache 2.2.4下载地址:http://cztele1.skycn.com/down/apache_2.2.4-win32-x86-no_ssl.zip 2. Tomcat 6.0.16下载地址:http://apache.mirror.phpchina.co ... e-tomcat-6.0.16.zip 3. JDK下载地址:http://cds.sun.com/is			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kMLRWO3.html" rel="bookmark" class="title">quartz 定时</a>
					<div>
						spring3不支持quartz2 1.业务调度的类(就是你想要做的事情的逻辑部门) public class QuartzTest { public void  quartzTest(){ Syst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bn5EV0.html" rel="bookmark" class="title">ubuntu 更换系统语言，Change System Language</a>
					<div>
						1.打开设置,打开“Language Support”. 2.如果列表中没有你的语言,点击“Install/Remove Language”,下拉选择你的语言,点击“Apply Changes”. 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZvvP0.html" rel="bookmark" class="title">Android中fill&lowbar;parent、match&lowbar;parent及wrap&lowbar;content有什么区别</a>
					<div>
						三个属性都用来适应视图的水平或垂直大小,一个以视图的内容或尺寸为基础的布局比精确地指定视图范围更加方便. 1)fill_parent 设置一个构件的布局为fill_parent将强制性地使构件扩展,以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZAQnD0.html" rel="bookmark" class="title">负载均衡之iptables&sol;nat模式</a>
					<div>
						Iptables和NAT 结合,也能够实现简单的负载均衡. 简介 iptables的前身叫ipfirewall (内核1.x时代),这是一个作者从freeBSD上移植过来的,能够工作在内核当中的,对数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418mVX3.html" rel="bookmark" class="title">读文件使用feof&lpar;&rpar;多读一次的问题</a>
					<div>
						读文件使用feof()多读一次的问题 这是一个经典的错误, 很多教科上都是这么写的.  在读完文件的最后一个字符后,fp-&gt;flag仍然没有被置为_IOEOF,因而feof()仍然没有探测到文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nz8lw4.html" rel="bookmark" class="title">iOS 关于 设计模式 与网友讨论实录</a>
					<div>
						关于 设计模式 与网友讨论实录 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&quot;创作公用协议 转载请保留 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXOno4.html" rel="bookmark" class="title">linux&lowbar;文件系统及文件管理基础</a>
					<div>
						文件系统:rootfs: 根文件系统 FHS: Linux /boot: 系统启动相关文件,如内核.initrd,以及grub(bootloader)    /dev: 设备文件       设备文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgmK93.html" rel="bookmark" class="title">蓝懿教育九月三十日记录</a>
					<div>
						单词:segmented被分割的  index指针.指标current现在的 代码创建 NSArray *itemName = [NSArray arrayWithObjects:@&quot;鸡翅& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JY2793.html" rel="bookmark" class="title">阿里前端的困局与突围</a>
					<div>
						最近发了两条微博: 想起克军的一句话:前端研究,研究个屁~ 的确如此呀.补充下联:前端设计,设计个屁~ 前端目前最大的困境是,如 HTML 一样,无论你承不承认,市场上并不太需要 HTML 高手. 微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mV9x0.html" rel="bookmark" class="title">Jquery 延迟对象</a>
					<div>
						延迟对象,在jQuery的1.5引入,是通过调用jQuery.Deferred()方法创建一个可链式调用的工具对象. 它可以注册多个回调到回调队列, 调用回调队列,准备代替任何同步或异步函数的成功或失 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5ZYk0.html" rel="bookmark" class="title">点击增加元素</a>
					<div>
						111222()3333444()().((ival){ })().((){         len =().select = (+(len-)).().(+len).(select)text=+le ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQDZoM.html" rel="bookmark" class="title">&lpar;原创&rpar;c&num;学习笔记03--变量和表达式04--表达式01--数学运算符</a>
					<div>
						3.4  表达式 把变量和字面值(在使用运算符时,它们都称为操作数)与运算符组合起来,就可以创建表达式,它是计算的基本构件. 本章主要介绍数学和赋值运算符,而逻辑运算符将在第4章中介绍,主要论述控制程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koPez0.html" rel="bookmark" class="title">POJ2157Maze&lbrack;DFS &excl;&rsqb;</a>
					<div>
						Maze Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 3818   Accepted: 1208 Description  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klrJj3.html" rel="bookmark" class="title">JAVA中的多线程&lpar;六&rpar;</a>
					<div>
						生产者消费者 1 class Resource 2 { 3 private String name; 4 private int count = 1; 5 private boolean flag = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPeldy0.html" rel="bookmark" class="title">让你的JS更优雅的小技巧</a>
					<div>
						首先,看一个非常不优雅的例子: 看到这段代码,虽然代码很短,但是一眼看上去就不想再看了,也就是没什么可读性.这段代码,没有封装,随意定义一个变量都是全局变量,这样在多人开发或者是大型开发中,极其容易造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rygyM.html" rel="bookmark" class="title">识别长按</a>
					<div>
						最近微信新增了一个功能:长按识别验证码. 原理是这样的:检测长按事件---触发--&gt;截取图片中的验证码 关于长按,我们可以这么处理: 1,点击开始时(onMouseDown||onTouchSt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQnBKM.html" rel="bookmark" class="title">C&plus;&plus;技术问题总结-第7篇 map、vector、list、deque各自的使用场合</a>
					<div>
						map是关联式的,vector.list.deque是序列式的. map:底层机制RB-tree(红黑树),元素自动排序,键值对. vector:操作方式与array相似,动态空间增长.是连续性空间, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pDLnK4.html" rel="bookmark" class="title">UESTC - 1222 Sudoku</a>
					<div>
						Yi Sima was one of the best counselors of Cao Cao. He likes to play a funny game himself. It looks l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K1QOK4.html" rel="bookmark" class="title">用异或操作实现的交换函数用以实现数组逆置中需要注意的问题</a>
					<div>
						用元素交换函数实现数组逆置很简单,如下面代码:(数组左右元素交换) #include&lt;iostream&gt; #include&lt;stdlib.h&gt; using namespace  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xxZGQ0.html" rel="bookmark" class="title">node-webkit 主页面和 iframe 页通讯</a>
					<div>
						&lt;html lang=&quot;en-US&quot;&gt; &lt;head&gt; &lt;title&gt;Hello World!&lt;/title&gt; &lt;style&g ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
